=== library/AnalogueCM/CMakeLists.txt ===

SET(AN_CM_resources
etd.mod
etd.ifs
FNXSPICECM.mod
FNXSPICECM.ifs
RFind.mod
RFind.ifs
)

INSTALL( FILES ${AN_CM_resources} DESTINATION share/${QUCS_NAME}/library/AnalogueCM )
