=== library/MESFETs/CMakeLists.txt ===

SET(MESFETs_resources
curtice1.mod
curtice1.ifs
)

INSTALL( FILES ${MESFETs_resources} DESTINATION share/${QUCS_NAME}/library/MESFETs )
