=== debian/control ===
Source: qucs-s
Section: electronics
Priority: optional
Build-Depends: debhelper (>> 4.0.0),libc6, flex, bison, qtbase5-dev, qttools5-dev, libqt5svg5-dev, gperf, dos2unix
Maintainer: Vadim Kuznetsov <ra3xdh@gmail.com>

Package: qucs-s
Version: 24.2.1
Standards-Version: 24.2.1
Section: electronics
Priority: optional
Architecture: any
Depends: libc6, libqt5gui5, libqt5core5a, libqt5svg5, libqt5widgets5, libqt5printsupport5 
Recommends: ngspice
Maintainer: Vadim Kuznetsov <ra3xdh@gmail.com>
Description: Quite Universal Circuit Simulator with SPICE (Qucs-S) 
 allows to simulate electronic circuits with SPICE-compatible kernels
